//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Mon May  8 18:10:56 PDT 2006
// Filename:      ...vamp-plugin-sdk/examples/plugins.cpp
// Syntax:        ANSI99 C++; vamp 1.0 plugin
//
// Description:   Automatically generated file based on the 
//                vamp sdk file examples/plugins.cpp
//

#include <vamp/vamp.h>
#include "PluginAdapter.h"

#include "MzChronogram.h"
#include "MzHarmonicSpectrum.h"
#include "MzNevermore.h"
#include "MzPitchPower.h"
#include "MzPowerCurve.h"
#include "MzPowerscape.h"
#include "MzSilenceFinder.h"
#include "MzSpectralFlatness.h"
#include "MzSpectralFlux.h"
#include "MzSpectrogramClient.h"
#include "MzSpectrogramFFTW.h"
#include "MzSpectrogramHost.h"
#include "MzSummation.h"

static Vamp::PluginAdapter<MzChronogram> mzChronogramAdapter;
static Vamp::PluginAdapter<MzHarmonicSpectrum> mzHarmonicSpectrumAdapter;
static Vamp::PluginAdapter<MzNevermore> mzNevermoreAdapter;
static Vamp::PluginAdapter<MzPitchPower> mzPitchPowerAdapter;
static Vamp::PluginAdapter<MzPowerCurve> mzPowerCurveAdapter;
static Vamp::PluginAdapter<MzPowerscape> mzPowerscapeAdapter;
static Vamp::PluginAdapter<MzSilenceFinder> mzSilenceFinderAdapter;
static Vamp::PluginAdapter<MzSpectralFlatness> mzSpectralFlatnessAdapter;
static Vamp::PluginAdapter<MzSpectralFlux> mzSpectralFluxAdapter;
static Vamp::PluginAdapter<MzSpectrogramClient> mzSpectrogramClientAdapter;
static Vamp::PluginAdapter<MzSpectrogramFFTW> mzSpectrogramFFTWAdapter;
static Vamp::PluginAdapter<MzSpectrogramHost> mzSpectrogramHostAdapter;
static Vamp::PluginAdapter<MzSummation> mzSummationAdapter;

// Pre vamp 1.0 interface:
//const VampPluginDescriptor *vampGetPluginDescriptor(unsigned int index) {

const VampPluginDescriptor *vampGetPluginDescriptor(
      unsigned int vampApiVersion, unsigned int index) {
   if (vampApiVersion < 1) {
       return 0;
   }

   const char* setinfo = "@@VampPluginSet@" __DATE__ "@MzChronogram; MzHarmonicSpectrum; MzNevermore; MzPitchPower; MzPowerCurve; MzPowerscape; MzSilenceFinder; MzSpectralFlatness; MzSpectralFlux; MzSpectrogramClient; MzSpectrogramFFTW; MzSpectrogramHost; MzSummation@@";
   if (setinfo[0] != '@') { 
      std::cerr << "This is a dummy statment: " << setinfo << std::endl;
   }

    switch (index) {
       case  0: return mzChronogramAdapter.getDescriptor();
       case  1: return mzHarmonicSpectrumAdapter.getDescriptor();
       case  2: return mzNevermoreAdapter.getDescriptor();
       case  3: return mzPitchPowerAdapter.getDescriptor();
       case  4: return mzPowerCurveAdapter.getDescriptor();
       case  5: return mzPowerscapeAdapter.getDescriptor();
       case  6: return mzSilenceFinderAdapter.getDescriptor();
       case  7: return mzSpectralFlatnessAdapter.getDescriptor();
       case  8: return mzSpectralFluxAdapter.getDescriptor();
       case  9: return mzSpectrogramClientAdapter.getDescriptor();
       case  10: return mzSpectrogramFFTWAdapter.getDescriptor();
       case  11: return mzSpectrogramHostAdapter.getDescriptor();
       case  12: return mzSummationAdapter.getDescriptor();
       default: return 0;
    }
}
